
-- (c) MP-I and CP (1998/99-2008/09)

module Nat  where

import Cp

-- (1) Datatype definition -----------------------------------------------------

-- data Nat = 0 | succ Nat   -- in fact: Haskell Integer is used as carrier type

inNat = either (const 0) succ

outNat 0 = Left ()
outNat (n+1) = Right n

-- NB: inNat and outNat isomorphisms only if restricted to non-negative integers

-- (2) Ana + cata + hylo -------------------------------------------------------

cataNat g   = g . recNat (cataNat g) . outNat
recNat f    = id -|- f
anaNat h    = inNat . (recNat (anaNat h) ) . h
hyloNat g h = cataNat g . anaNat h
paraNat g   = g . recNat (split id (paraNat g)) . outNat

-- (3) Map ---------------------------------------------------------------------

-- (4) Examples ----------------------------------------------------------------

for :: (Integral a1) => (a -> a) -> a -> a1 -> a
-- for is the "fold" of natural numbers
for b i = cataNat (either (const i) b)

soma a = cataNat (either (const a) succ)

multip a = cataNat (either (const 0) (a+))

exp a = cataNat (either (const 1) (a*))

sq = paraNat (either (const 0) g)
         where g(n,r) = oddn n + r
               oddn n = 2*n+1

factorial = paraNat (either (const 1) g)
         where g(n,r) = (n+1) * r

